package LATMOS::Accounts::Web::Controller::MassEdit;

use strict;
use warnings;
use base 'LATMOS::Accounts::Web::Controller';

=head1 NAME

LATMOS::Accounts::Web::Controller::MassEdit - Catalyst Controller

=head1 DESCRIPTION

Catalyst Controller.

=head1 METHODS

=cut


=head2 index 

=cut

sub index : Private {
    my ( $self, $c ) = @_;

    my $base = $c->stash->{db} = $c->model('Accounts')->db;

    if ($c->req->param('otype') && $c->req->param('otype') ne $c->session->{filter}{otype}) {
        $c->session->{filter} = undef;
        $c->stash->{filter}{otype} = $c->req->param('otype');
        $c->session->{massedit}{attrcol} = undef;
    } else {
        $c->stash->{filter} = $c->session->{filter};
        if ($c->req->params->{attrcol}) {
            $c->session->{massedit}{attrcol} = [ grep { $_ } $c->req->param('attrcol') ];
        } else {
            $c->req->params->{attrcol} = $c->session->{massedit}{attrcol};
        }
    }
    $c->stash->{ofilter} = $c->model('AttrFilter', $c->stash->{filter}{otype});

    if (($c->req->param('_change') || '') eq 'all') {
        my %change;
        foreach ($c->req->param('attrcol')) {
            $change{$_} = $c->req->param($_) || undef;
            delete($c->req->params->{$_});
        }
        foreach my $id ($c->req->param('objid')) {
            my $obj = $base->get_object($c->req->param('otype'), $id) or next;
            $obj->set_c_fields(%change);
        }
        $base->commit;
    } elsif (($c->req->param('_change') || '') eq 'perobj') {
        foreach my $id ($c->req->param('objid')) {
            my $obj = $base->get_object($c->req->param('otype'), $id) or next;
            my %change;
            foreach ($c->req->param('attrcol')) {
                $change{$_} = $c->req->param($id . '_' . $_) || undef;
                delete($c->req->params->{$id . '_' . $_});
            }
            $obj->set_c_fields(%change);
        }
        $base->commit;
    }
    $c->session->{filter} = $c->stash->{filter};
}


=head1 AUTHOR

Thauvin Olivier

=head1 LICENSE

This library is free software, you can redistribute it and/or modify
it under the same terms as Perl itself.

=cut

1;
